/*
 * InfoWindow.h
 *
 * Written by Matt Pauker
 *
 * Last modified: 9/14/96
 */

#ifndef INFO_WINDOW_H
#define INFO_WINDOW_H

#ifndef LOCKABLE_LIST_H
#include "LockableList.h"
#endif

class MessageDroppedFilter;
class SignatureView;

class InfoWindow : public BWindow
{
	public:
								InfoWindow(long topX, long topY);
								~InfoWindow();
	virtual void	MessageReceived(BMessage *message);
	virtual bool	QuitRequested();

					void	NextFocus();
					void	AddRef(record_ref ref);
					void  AddRefsInDir(record_ref dirRef, bool doRecursively);
					void	SaveFile(record_ref ref);
					bool	DoSave();
					bool	HasRef(record_ref theRef);
					void	Mark(record_ref ref);
					void	SetChanged(bool flag);
					void	ResetSigs();
					
	private:

	ulong					savedType, savedApp;
	SignatureView	*typeView, *appView;

	BMenuBar			*menuBar;
	BMenu 				*filesMenu;
	
	LockableList	*refList;
	
	MessageDroppedFilter	*myFilter;
};

#endif