/*
 * SigView.cpp
 *
 * Written by Matt Pauker
 *
 * Last modified: 10/26/96
 */

#ifndef SIG_VIEW_H
#include "SigView.h"
#endif

#ifndef INFO_WINDOW_H
#include "InfoWindow.h"
#endif

#ifndef CHANGE_CONSTANTS_H
#include "ChangeConstants.h"
#endif

SignatureView::SignatureView(BRect frame, const char *name, const char *label) :
	BTextControl(frame, name, label, "" , NULL)
{
	SetModificationMessage(new BMessage(TEXT_CHANGED));
	SetDivider(40);
}

void SignatureView::AttachedToWindow()
{
	BTextView *textView;
	
	textView = (BTextView *)ChildAt(0);
	textView->SetMaxChars(4);		// Signatures should only be 4 characters long	

	BTextControl::AttachedToWindow();
}

void SignatureView::MessageReceived(BMessage *message)
{
	BTextView *textView;
	textView = (BTextView *)ChildAt(0);
	
	switch (message->what)
	{
		case SELECT_ALL:
			textView->SelectAll();
		break;
		case B_DELETE:
			textView->Delete();
		break;
		default:
			BTextControl::MessageReceived(message);
		break;
	}
}

void SignatureView::SetSig(ulong code)
// Turns code into a string and places that string in the text view
{
	BTextView *textView;
	textView = (BTextView *)ChildAt(0);
	if (code > 0)
		textView->SetText((char *)&code, 4);
	else
		textView->SetText("", 0);
}

ulong SignatureView::GetSig()
// Gets the string in the text view and turns it into a ulong, so that it can be saved
{
	if (TextLength() > 0)
		return * (ulong *)Text();
	else
		return 0;
}


void SignatureView::SelectAll()
// Selects all the text in the text view
{
	BTextView *textView;
	
	textView = (BTextView *)ChildAt(0);
	textView->SelectAll();
}

long SignatureView::TextLength()
// Returns the number of characters in the text view
{
	BTextView *textView;
	
	textView = (BTextView *)ChildAt(0);
	return textView->TextLength();
}